package me.bindigo;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.text.DateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.Formatter;
import java.util.HashMap;
import java.util.Scanner;
import java.util.StringTokenizer;

import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.plugin.java.JavaPlugin;

public class MinecraftChatFilter extends JavaPlugin{
		
	private Scanner scanner;
	
	static long numberOfEvents;  // Stores stuff for statistics
	static long numberOfBans;
	static long numberOfKicks;
	static long numberOfHides;
	
	public static ArrayList<String[]> words = new ArrayList<String[]>();  // Contains the list of swear words, all imported from chatfilter.txt
	static ArrayList<String> ignore = new ArrayList<String>();  // List of characters to ignore, from ignore.txt
	static HashMap<String, String> replace = new HashMap<String, String>();  // Hashmap of characters to replace, from replace.txt
	
	@Override
	public void onEnable()
	{
		// Initialize file scanner for chatfilter.txt
				try
				{
					InputStream stream = getClass().getResourceAsStream("/chatfilter.txt");
					scanner = new Scanner(stream);
				}
				catch(Exception e)
				{
					getLogger().info("An error occurred, probably couldn't find chatfilter.txt.  Try placing it in the root folder of jar file!");
				}
						
				// Read and store file data
				StringTokenizer separator;
				// Variable for counting number of words
				int wordCount = 0;
				
						while(scanner.hasNextLine())
						{
							// Makes sure that a comment isn't accidentally added to list of words
							String currentLine = scanner.nextLine();
							if(!currentLine.startsWith("//")) // If the line doesn't start with the comment symbol I made up
							{
								separator = new StringTokenizer(currentLine); // Gets the full string into a stringtokenizer, which will separate the data
								String[] tempArray = {separator.nextToken(), separator.nextToken(), separator.nextToken(), separator.nextToken()};  // Adds the data in the following order:  the word itself, spaces/nospaces, if it ignores the characters on the ignorelist, and the punshment level
								
								words.add(tempArray);
								wordCount++;
							}
						}
						
						getLogger().info("Just loaded " + wordCount + " words!");
				
				// Close file stream
				scanner.close();
				
				
				
				// Initialize file scanner for ignore.txt
				Scanner scanner1 = null;
				try
				{
					InputStream stream1 = getClass().getResourceAsStream("/ignore.txt");
					scanner1 = new Scanner(stream1);
				}
				catch(Exception e)
				{
					getLogger().info("An error occured, probably couldn't find ignore.txt.  Try placing it in the root folder of jar file!");
				}
						
				// Read and store file data
						while(scanner1.hasNextLine())
						{
							ignore.add(scanner1.nextLine());
						}
				
				// Close file stream
						
				scanner1.close();
				
				// Initialize file scanner for replace.txt
				Scanner scanner2 = null;
				try
				{
					InputStream stream2 = getClass().getResourceAsStream("/replace.txt");
					scanner2 = new Scanner(stream2);
				}
				catch(Exception e)
				{
					getLogger().info("An error occured, probably couldn't find replace.txt.  Try placing it in the root folder of jar file!");
				}
						
				// Read and store file data
						while(scanner2.hasNextLine())
						{
							String replaced = scanner2.next();
							String replacer = scanner2.next();
							
							replace.put(replaced, replacer);
						}
				
				// Close file stream
						
				scanner2.close();
				
				// Initialize the statistics
				File statistics = new File("MinecraftChatFilter" + File.separator + "MinecraftChatFilterStats" + ".txt");
				if(statistics.exists()) // If MinecraftChatFilterStats.txt exists already
				{
					try {
						Scanner scanner3 = new Scanner(statistics);
						
						while(scanner3.hasNextLine()) // Read from stats file
						{
							numberOfEvents = scanner3.nextLong();
							numberOfBans = scanner3.nextLong();
							numberOfKicks = scanner3.nextLong();
							numberOfHides = scanner3.nextLong();
						}
						
						scanner3.close();
						
					} catch (FileNotFoundException e) {
						getLogger().info("Had trouble accessing MinecraftChatFilterStats.txt!");
					}
				}
				else
				{
					// Write stats if it doesn't exist!
					try {
						statistics.getParentFile().mkdirs();
						try {
							statistics.createNewFile();
						} catch (IOException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
						Formatter stats = new Formatter(statistics);
						
						stats.format("0\r\n0\r\n0\r\n0");
						
						stats.close();
						
					} catch (FileNotFoundException e) {
						getLogger().info("Had trouble writing MinecraftChatFilterStats.txt!");
					}
				}
				
		new PlayerListener(this);
	}
	
	@Override
	public void onDisable()
	{
		// Overwrite stats!
		try {
			File statistics = new File("MinecraftChatFilter" + File.separator + "MinecraftChatFilterStats.txt");
			statistics.getParentFile().mkdirs();
			try {
				statistics.createNewFile();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			Formatter stats = new Formatter(statistics);
			stats.format("%s\r\n%s\r\n%s\r\n%s", Long.toString(numberOfEvents), Long.toString(numberOfBans), Long.toString(numberOfKicks), Long.toString(numberOfHides));  
			stats.close();
		} catch (FileNotFoundException e) {
			getLogger().info("Had trouble overwriting MinecraftChatFilterStats.txt!");
		}
	}
	
	public boolean onCommand(CommandSender sender, Command cmd, String label, String[] args)
	{
		if(cmd.getName().equalsIgnoreCase("filterstats") && sender instanceof Player)
		{
			if(sender.isOp())  // Player needs to be an op
			{
				Player player = (Player) sender;
				
				player.sendMessage(ChatColor.DARK_AQUA + "=======================================\nNUMBER OF TOTAL EVENTS = " + Long.toString(MinecraftChatFilter.numberOfEvents) + "\nNUMBER OF EVENTS RESULTING IN A BAN = " + Long.toString(MinecraftChatFilter.numberOfBans) + "\nNUMBER OF EVENTS RESULTING IN A KICK = " + Long.toString(MinecraftChatFilter.numberOfKicks) + "\nNUMBER OF EVENTS RESULTING IN A HIDE = " + Long.toString(MinecraftChatFilter.numberOfHides) + "\n=======================================");
				
				return true;
			}
			else
			{
				Player player = (Player) sender;
				
				player.sendMessage(ChatColor.RED + "You do not have permission to use this command.");
			}
		}
		else if(cmd.getName().equalsIgnoreCase("say") && sender instanceof Player)
		{
			MinecraftChatFilter.numberOfEvents++;
			
						// Gets player from command
						Player player = (Player) sender;
						
						if(args.length > 0) // There are arguments(not just /say)
						{
							// Starts input stringbuffer
							StringBuffer sayInput = new StringBuffer();
							
							for(String arg: args)
							{
								sayInput.append(arg + " "); // Gets what the player said.  Since each space separates two "arguments", the message to send is read as different arguments.  This just puts the arguments back into one stringbuffer
							}
							
							sayInput.setLength(sayInput.length() - 1); // Trims off the extra space at the end
							
							// Checks the command input
							String[] punishment = PlayerListener.check(sayInput.toString());
							
							if(punishment[0].equals("BAN")) // Permanent ban
							{
								player.setBanned(true);
								player.kickPlayer(ChatColor.RED + "You have been permanently banned for using extremely vulgar language!           " + ChatColor.GRAY + "Believe you've been banned unfairly?  Contact the owner of the server immediately!");
								MinecraftChatFilter.numberOfBans++;

								try {
									File directory = new File("MinecraftChatFilter" + File.separator + "banlogs");
									
									if(!directory.exists()) // If MinecraftChatFilter folder doesn't exist
									{
										directory.mkdirs(); // Make it
									}
									
									Formatter formatter = new Formatter(directory + File.separator + player.getName() + ".txt");
									formatter.format("IGN: %s\r\nUUID: %s\r\nIP ADDRESS/PORT: %s\r\nCHAT MESSAGE(/SAY): %s\r\nDETECTED WORD: %s\r\nTIME: %s", player.getName(), player.getUniqueId(), player.getAddress().toString().replace("/", ""), sayInput, punishment[1], DateFormat.getDateTimeInstance(DateFormat.SHORT, DateFormat.LONG).format(new Date()));
									formatter.close();
									
								} catch (FileNotFoundException e) {
									// TODO Auto-generated catch block
									e.printStackTrace();
								}
								
							}	
							else if(punishment[0].equals("KICK")) // Kick
							{
								player.kickPlayer(ChatColor.RED + "You have been kicked for using vulgar language!");
								MinecraftChatFilter.numberOfKicks++;
							}
							else if(punishment[0].equals("HIDE"))  // Hide
							{
								// This is where you put/edit the code for the fake message!  In case a server rank changes their chat color or something
								player.sendMessage("<" + player.getDisplayName() + "> " + sayInput.toString());  // Send fake message!
								MinecraftChatFilter.numberOfHides++;
							}
							else if(punishment[0].equals("UNICODE")) // Invalid unicode characters detected!
							{
								player.sendMessage(ChatColor.RED + "Please, don't use invalid characters!");
								MinecraftChatFilter.numberOfHides++;
							}
							else // No words detected, do nothing
							{
								player.chat(sayInput.toString());
							}
						}
						else // Give player a usage message
						{
							player.sendMessage(ChatColor.RED + "Usage: /say <message ...>");
						}
						
						return true;
		}
		else if(cmd.getName().equalsIgnoreCase("tell") && sender instanceof Player)
		{
			// Gets player from command
						Player player = (Player) sender;
						
						if(args.length > 1)
						{
							// Starts input stringbuffer
							StringBuffer sayInput = new StringBuffer();
							
							for(int i = 1; i < args.length; i++) // Must start at index 1, because index 0 is the recipient's IGN.
							{
								sayInput.append(args[i] + " "); // Gets what the player said.  Since each space separates two "arguments", the message to send is read as different arguments.  This just puts the arguments back into one stringbuffer
							}
							
							sayInput.setLength(sayInput.length() - 1); // Trims off the extra space at the end
							
							// Checks the command input
							String[] punishment = PlayerListener.check(sayInput.toString());
							
							MinecraftChatFilter.numberOfEvents++;
							
							if(punishment[0].equals("BAN")) // Permanent ban
							{
								player.setBanned(true);
								player.kickPlayer(ChatColor.RED + "You have been permanently banned for using extremely vulgar language!           " + ChatColor.GRAY + "Believe you've been banned unfairly?  Contact the owner of the server immediately!");
								MinecraftChatFilter.numberOfBans++;

								try {
									File directory = new File("MinecraftChatFilter" + File.separator + "banlogs");
									
									if(!directory.exists()) // If MinecraftChatFilter folder doesn't exist
									{
										directory.mkdirs(); // Make it
									}
									
									Formatter formatter = new Formatter(directory + File.separator + player.getName() + ".txt");
									formatter.format("IGN: %s\r\nUUID: %s\r\nIP ADDRESS/PORT: %s\r\nPRIVATE MESSAGE: %s\r\nMESSAGE RECIPIENT: %s\r\nDETECTED WORD: %s\r\nTIME: %s", player.getName(), player.getUniqueId(), player.getAddress().toString().replace("/", ""), sayInput, args[0], punishment[1], DateFormat.getDateTimeInstance(DateFormat.SHORT, DateFormat.LONG).format(new Date()));
									formatter.close();
									
								} catch (FileNotFoundException e) {
									// TODO Auto-generated catch block
									e.printStackTrace();
								}
								
							}	
							else if(punishment[0].equals("KICK")) // Kick
							{
								player.kickPlayer(ChatColor.RED + "You have been kicked for using vulgar language!");
								MinecraftChatFilter.numberOfKicks++;
							}
							else if(punishment[0].equals("HIDE"))
							{
								Player target = Bukkit.getPlayer(args[0]);
								
								if(target != null)
								{
									if(target.equals(player)) // If the player is sending a pm to theirselves
									{
										player.sendMessage("You can't send a private message to yourself!");
										return false;
									}
									player.sendMessage(ChatColor.BLUE + "To " +  ChatColor.GREEN + target.getName() + ": " + ChatColor.BLUE + sayInput.toString()); // Sends confirmation message to sender, but NOT the target.  Hides the PM
									MinecraftChatFilter.numberOfHides++;
									return false;
								}
								else
								{
									player.sendMessage("That player cannot be found");
								}
							}
							else if(punishment[0].equals("UNICODE")) // Invalid unicode characters detected!
							{
								player.sendMessage(ChatColor.RED + "Please, don't use invalid characters!");
								MinecraftChatFilter.numberOfHides++;
							}
							else // No words detected, send the pm if possible
							{
								Player target = Bukkit.getPlayer(args[0]);
								
								if(target != null)
								{
									if(target.equals(player)) // If the player is sending a pm to theirselves
									{
										player.sendMessage("You can't send a private message to yourself!");
										return false;
									}
									target.sendMessage(ChatColor.BLUE + "From " + ChatColor.GREEN + player.getName() + ": " + ChatColor.BLUE + sayInput.toString());
									player.sendMessage(ChatColor.BLUE + "To " +  ChatColor.GREEN + target.getName() + ": " + ChatColor.BLUE + sayInput.toString());
								}
								else
								{
									player.sendMessage("That player cannot be found");
								}
							}
						}
						else
						{
							player.sendMessage(ChatColor.RED + "Usage: /tell <player> <private message ...>");
						}
						
						return true;
		}
		else if(cmd.getName().equalsIgnoreCase("msg") && sender instanceof Player)
		{
			// Gets player from command
						Player player = (Player) sender;
						
						if(args.length > 1)
						{
							// Starts input stringbuffer
							StringBuffer sayInput = new StringBuffer();
							
							for(int i = 1; i < args.length; i++) // Must start at index 1, because index 0 is the recipient's IGN.
							{
								sayInput.append(args[i] + " "); // Gets what the player said.  Since each space separates two "arguments", the message to send is read as different arguments.  This just puts the arguments back into one stringbuffer
							}
							
							sayInput.setLength(sayInput.length() - 1); // Trims off the extra space at the end
							
							// Checks the command input
							String[] punishment = PlayerListener.check(sayInput.toString());
							
							MinecraftChatFilter.numberOfEvents++;
							
							if(punishment[0].equals("BAN")) // Permanent ban
							{
								player.setBanned(true);
								player.kickPlayer(ChatColor.RED + "You have been permanently banned for using extremely vulgar language!           " + ChatColor.GRAY + "Believe you've been banned unfairly?  Contact the owner of the server immediately!");
								MinecraftChatFilter.numberOfBans++;

								try {
									File directory = new File("MinecraftChatFilter" + File.separator + "banlogs");
									
									if(!directory.exists()) // If MinecraftChatFilter folder doesn't exist
									{
										directory.mkdirs(); // Make it
									}
									
									Formatter formatter = new Formatter(directory + File.separator + player.getName() + ".txt");
									formatter.format("IGN: %s\r\nUUID: %s\r\nIP ADDRESS/PORT: %s\r\nPRIVATE MESSAGE: %s\r\nMESSAGE RECIPIENT: %s\r\nDETECTED WORD: %s\r\nTIME: %s", player.getName(), player.getUniqueId(), player.getAddress().toString().replace("/", ""), sayInput, args[0], punishment[1], DateFormat.getDateTimeInstance(DateFormat.SHORT, DateFormat.LONG).format(new Date()));
									formatter.close();
									
								} catch (FileNotFoundException e) {
									// TODO Auto-generated catch block
									e.printStackTrace();
								}
								
							}	
							else if(punishment[0].equals("KICK")) // Kick
							{
								player.kickPlayer(ChatColor.RED + "You have been kicked for using vulgar language!");
								MinecraftChatFilter.numberOfKicks++;
							}
							else if(punishment[0].equals("HIDE"))
							{
								Player target = Bukkit.getPlayer(args[0]);
								
								if(target != null)
								{
									if(target.equals(player)) // If the player is sending a pm to theirselves
									{
										player.sendMessage("You can't send a private message to yourself!");
										return false;
									}
									player.sendMessage(ChatColor.BLUE + "To " +  ChatColor.GREEN + target.getName() + ": " + ChatColor.BLUE + sayInput.toString()); // Sends message to sender, but NOT the target.  Hides the PM
									MinecraftChatFilter.numberOfHides++;
									return false;
								}
								else
								{
									player.sendMessage("That player cannot be found");
								}
							}
							else if(punishment[0].equals("UNICODE")) // Invalid unicode characters detected!
							{
								player.sendMessage(ChatColor.RED + "Please, don't use invalid characters!");
								MinecraftChatFilter.numberOfHides++;
							}
							else // No words detected, send the pm if possible
							{
								Player target = Bukkit.getPlayer(args[0]);
								
								if(target != null)
								{
									if(target.equals(player)) // If the player is sending a pm to theirselves
									{
										player.sendMessage("You can't send a private message to yourself!");
										return false;
									}
									target.sendMessage(ChatColor.BLUE + "From " + ChatColor.GREEN + player.getName() + ": " + ChatColor.BLUE + sayInput.toString());
									player.sendMessage(ChatColor.BLUE + "To " +  ChatColor.GREEN + target.getName() + ": " + ChatColor.BLUE + sayInput.toString());
								}
								else
								{
									player.sendMessage("That player cannot be found");
								}
							}
						}
						else
						{
							player.sendMessage(ChatColor.RED + "Usage: /msg <player> <private message ...>");
						}
						
						return true;
		}
		else if(cmd.getName().equalsIgnoreCase("w") && sender instanceof Player)
		{
			// Gets player from command
						Player player = (Player) sender;
						
						if(args.length > 1)
						{
							// Starts input stringbuffer
							StringBuffer sayInput = new StringBuffer();
							
							for(int i = 1; i < args.length; i++) // Must start at index 1, because index 0 is the recipient's IGN.
							{
								sayInput.append(args[i] + " "); // Gets what the player said.  Since each space separates two "arguments", the message to send is read as different arguments.  This just puts the arguments back into one stringbuffer
							}
							
							sayInput.setLength(sayInput.length() - 1); // Trims off the extra space at the end
							
							// Checks the command input
							String[] punishment = PlayerListener.check(sayInput.toString());
							
							MinecraftChatFilter.numberOfEvents++;
							
							if(punishment[0].equals("BAN")) // Permanent ban
							{
								player.setBanned(true);
								player.kickPlayer(ChatColor.RED + "You have been permanently banned for using extremely vulgar language!           " + ChatColor.GRAY + "Believe you've been banned unfairly?  Contact the owner of the server immediately!");
								MinecraftChatFilter.numberOfBans++;

								try {
									File directory = new File("MinecraftChatFilter" + File.separator + "banlogs");
									
									if(!directory.exists()) // If MinecraftChatFilter folder doesn't exist
									{
										directory.mkdirs(); // Make it
									}
									
									Formatter formatter = new Formatter(directory + File.separator + player.getName() + ".txt");
									formatter.format("IGN: %s\r\nUUID: %s\r\nIP ADDRESS/PORT: %s\r\nPRIVATE MESSAGE: %s\r\nMESSAGE RECIPIENT: %s\r\nDETECTED WORD: %s\r\nTIME: %s", player.getName(), player.getUniqueId(), player.getAddress().toString().replace("/", ""), sayInput, args[0], punishment[1], DateFormat.getDateTimeInstance(DateFormat.SHORT, DateFormat.LONG).format(new Date()));
									formatter.close();
									
								} catch (FileNotFoundException e) {
									// TODO Auto-generated catch block
									e.printStackTrace();
								}
								
							}	
							else if(punishment[0].equals("KICK")) // Kick
							{
								player.kickPlayer(ChatColor.RED + "You have been kicked for using vulgar language!");
								MinecraftChatFilter.numberOfKicks++;
							}
							else if(punishment[0].equals("HIDE"))
							{
								Player target = Bukkit.getPlayer(args[0]);
								
								if(target != null)
								{
									if(target.equals(player)) // If the player is sending a pm to theirselves
									{
										player.sendMessage("You can't send a private message to yourself!");
										return false;
									}
									player.sendMessage(ChatColor.BLUE + "To " +  ChatColor.GREEN + target.getName() + ": " + ChatColor.BLUE + sayInput.toString()); // Sends message to sender, but NOT the target.  Hides the PM
									MinecraftChatFilter.numberOfHides++;
									return false;
								}
								else
								{
									player.sendMessage("That player cannot be found");
								}
							}
							else if(punishment[0].equals("UNICODE")) // Invalid unicode characters detected!
							{
								player.sendMessage(ChatColor.RED + "Please, don't use invalid characters!");
								MinecraftChatFilter.numberOfHides++;
							}
							else // No words detected, send the pm if possible
							{
								Player target = Bukkit.getPlayer(args[0]);
								
								if(target != null)
								{
									if(target.equals(player)) // If the player is sending a pm to theirselves
									{
										player.sendMessage("You can't send a private message to yourself!");
										return false;
									}
									target.sendMessage(ChatColor.BLUE + "From " + ChatColor.GREEN + player.getName() + ": " + ChatColor.BLUE + sayInput.toString());
									player.sendMessage(ChatColor.BLUE + "To " +  ChatColor.GREEN + target.getName() + ": " + ChatColor.BLUE + sayInput.toString());
								}
								else
								{
									player.sendMessage("That player cannot be found");
								}
							}
						}
						else
						{
							player.sendMessage(ChatColor.RED + "Usage: /w <player> <private message ...>");
						}
						
						return true;
		}
		else if(cmd.getName().equalsIgnoreCase("tellraw") || sender instanceof Player)
		{
			Player player = (Player) sender;
			
			player.sendMessage(ChatColor.RED + "You don't have permission to use this command!"); // Stops players from using tellraw.  The server and other plugins can still send JSON messages I think.  I don't know how to filter JSON-formatted text, and doing so would be impractical and bug-ridden
		}
		return false;
	}
}
