package me.bindigo;

import java.io.File;
import java.io.FileNotFoundException;
import java.text.DateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.Formatter;
import java.util.List;

import org.bukkit.ChatColor;
import org.bukkit.entity.HumanEntity;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.SignChangeEvent;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.event.player.PlayerChatEvent;
import org.bukkit.event.player.PlayerEditBookEvent;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.inventory.AnvilInventory;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.InventoryView;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.BookMeta;
import org.bukkit.inventory.meta.ItemMeta;

@SuppressWarnings("deprecation")
class PlayerListener implements Listener{
	
	public PlayerListener(MinecraftChatFilter plugin)
	{
		plugin.getServer().getPluginManager().registerEvents(this, plugin);  // Does something important
	}
	
	public static String[] check(String CheckInput)
	{
				// Checks for invalid characters
				for(int i = 0; i < CheckInput.length(); i++)
				{
					if((int)CheckInput.charAt(i) < 32 || (int)CheckInput.charAt(i) > 126)  // If a character that is not basic latin (unicode 32 to 126) is detected
					{
						String[] unicode = new String[2];  
						unicode[0] = "UNICODE";
						return unicode;
					}
				}
				
				// Converts input to uppercase
				CheckInput = CheckInput.toUpperCase();
				
				// Replaces certain characters
				for(String replaced: MinecraftChatFilter.replace.keySet())
				{
					CheckInput = CheckInput.replace(replaced, MinecraftChatFilter.replace.get(replaced));
				}
				
				// Gets CheckInputWithoutIgnore
				String CheckInputWithoutIgnore = CheckInput;
				
				// Removes everything from ignore list
				for(String removed: MinecraftChatFilter.ignore)
				{
					CheckInput = CheckInput.replace(removed, "");
				}
				
				String[] punishment = new String[2];
				punishment[0] = "NOTHING";
				
				// Checks without spaces
				for(String[] wordData: MinecraftChatFilter.words)
				{
					if(wordData[1].equals("NOSPACES")) // If the word is nospaces
					{
						if(wordData[2].equals("IGNORETRUE")) // Ignoring all of the characters in the text file
						{
							if(CheckInput.replaceAll(" ", "").contains(wordData[0])) // If the word is detected
							{
								if(wordData[3].equals("HIDE")) // results in AT LEAST a hide
								{
									if(punishment[0].equals("NOTHING"))
									{
										punishment[0] = "HIDE";
									}
								}
								else if(wordData[3].equals("KICK")) // results in AT LEAST a kick
								{
									punishment[0] = "KICK";
								}
								else // Word is detected, needs a ban.  Could loop through rest of word list, but it's more efficient to just return the punishment quickly.  A ban is the words that can happen, so there is really nothing else to look for
								{
									punishment[0] = "BAN";
									punishment[1] = wordData[0];
									return punishment;
								}
							}
						}
						else // Not ignoring the characters in the text file.  Uses CheckInputWithoutIgnore
						{
							if(CheckInputWithoutIgnore.replaceAll(" ", "").contains(wordData[0])) // If the word is detected
							{
								if(wordData[3].equals("HIDE")) // results in AT LEAST a hide
								{
									if(punishment[0].equals("NOTHING"))
									{
										punishment[0] = "HIDE";
									}
								}
								else if(wordData[3].equals("KICK")) // results in AT LEAST a kick
								{
									punishment[0] = "KICK";
								}
								else // Word is detected that deserves a ban.  Super efficiency
								{
									punishment[0] = "BAN";
									punishment[1] = wordData[0];
									return punishment;
								}
							}
						}
					}
					else // If the word needs spaces around it
					{
						if(wordData[2].equals("IGNORETRUE")) // Ignoring all of the characters in the text file
						{
							if(CheckInput.equals(wordData[0]) || CheckInput.startsWith(wordData[0].concat(" ")) || CheckInput.endsWith(" ".concat(wordData[0])) || CheckInput.contains(" ".concat(wordData[0]).concat(" ")))  // IF IT CATCHES A WORD ON THE BEGINNING, END, OR MIDDLE
							{
								if(wordData[3].equals("HIDE")) // results in AT LEAST a hide
								{
									if(punishment[0].equals("NOTHING")) // The punishment is already lower than a hide.  You don't want to hide a message that deserves ban/kick!
									{
										punishment[0] = "HIDE";
									}
								}
								else if(wordData[3].equals("KICK")) // results in AT LEAST a kick
								{
									punishment[0] = "KICK";
								}
								else // Ban word detected, efficiency superhero
								{
									punishment[0] = "BAN";
									punishment[1] = wordData[0];
									return punishment;
								}
							}
						}
						else // wordData[2] equals ignorefalse!!!
						{
							if(CheckInputWithoutIgnore.equals(wordData[0]) || CheckInputWithoutIgnore.startsWith(wordData[0].concat(" ")) || CheckInputWithoutIgnore.endsWith(" ".concat(wordData[0])) || CheckInputWithoutIgnore.contains(" ".concat(wordData[0]).concat(" ")))  // IF IT CATCHES A WORD ON THE BEGINNING, END, OR MIDDLE
							{
								if(wordData[3].equals("HIDE")) // results in AT LEAST a hide
								{
									if(punishment[0].equals("NOTHING")) // Checks before setting to hide
									{
										punishment[0] = "HIDE";
									}
								}
								else if(wordData[3].equals("KICK")) // results in AT LEAST a kick
								{
									punishment[0] = "KICK";
								}
								else // Ban word detected
								{
									punishment[0] = "BAN";
									punishment[1] = wordData[0];
									return punishment;
								}
							}
						}
					}
				}
				
				// Returns the maximum punishment detected(Besides a ban, that would get returned as soon as it was detected)
				return punishment;
	}
	
	@EventHandler
	public void onBookEvent(PlayerEditBookEvent event)
	{
		MinecraftChatFilter.numberOfEvents++;
		
		// Sets unicode boolean variable for the book title and pages
		boolean unicode = false;
		
		// Gets player from event
				Player player = event.getPlayer();
				
				// Gets the text from the book pages
				BookMeta bookMeta = event.getNewBookMeta();
				
				List<String> bookText = bookMeta.getPages();
				String bookTitle = bookMeta.getTitle();
				ArrayList<String> banLogVisible = new ArrayList<String>(); // Sets the book pages that go into the actual ban log.  Stuff containing unicode characters won't be included, or checked for that matter.  We don't want someone messing around with file writing and unicode characters.
				
				// Checks the book title
				String[] punishment = check(bookTitle);
				
				if(punishment[0].equals("UNICODE"))
				{
					// Basicially, if the book's title contains unicode, the pages will still be checked
					unicode = true;
					bookTitle = "INVALID TITLE";
					punishment[0] = "NOTHING";
				}
				if(!punishment[0].equals("BAN")) // If the book title needs a ban, it won't check the book pages(waste of time)
				{
						for(String pageText: bookText)
						{
							// Checks the page text
							String[] checkPunishment = check(pageText);
							
							// Checks to increase punishment
							if(checkPunishment[0].equals("BAN")) // If a ban is detected
							{
								// Sets the proper ban stuff.  Must have the break in the code!
								punishment[0] = "BAN";
								punishment[1] = checkPunishment[1];
								banLogVisible.add(pageText);// Adds book page to the ban log ONLY IF there is no special unicode characters in it.
								break;
							}
							else if(checkPunishment[0].equals("KICK"))
							{
								banLogVisible.add(pageText);// adds book page to the ban log ONLY IF there is no special unicode characters in it.
								// Sets the punishment level to a kick, but keeps checking for ban-level threats.
								punishment[0] = "KICK";
							}
							else if(checkPunishment[0].equals("HIDE"))
							{
								banLogVisible.add(pageText);// Adds book page to the ban log ONLY IF there is no special unicode characters in it.
								if(punishment[0].equals("NOTHING"))
								{
									// Will hide message.  Must check for the punishment being lower than a hide already
									punishment[0] = "HIDE";
								}
							}
							else if(checkPunishment[0].equals("UNICODE"))
							{
								unicode = true;
							}
							else // If nothing is wrong
							{
								banLogVisible.add(pageText);// Adds book page to the ban log ONLY IF there is no special unicode characters in it.
							}
						}
					}
				
				if(punishment[0].equals("BAN")) // Permanent ban
				{
					event.setCancelled(true);  // Won't display the vulgar message
					player.setBanned(true);
					player.kickPlayer(ChatColor.RED + "You have been permanently banned for using extremely vulgar language!           " + ChatColor.GRAY + "Believe you've been banned unfairly?  Contact the owner of the server immediately!");
					MinecraftChatFilter.numberOfBans++;

					try {
						File directory = new File("MinecraftChatFilter" + File.separator + "banlogs");
						
						if(!directory.exists()) // If MinecraftChatFilter folder doesn't exist
						{
							directory.mkdir(); // Then make it
						}
						
						Formatter formatter = new Formatter(directory + File.separator + player.getName() + ".txt");
						formatter.format("IGN: %s\r\nUUID: %s\r\nIP ADDRESS/PORT: %s\r\nBOOK TITLE: %s\r\nBOOK MESSAGE: %s\r\nDETECTED WORD: %s\r\nTIME: %s", player.getName(), player.getUniqueId(), player.getAddress().toString().replace("/", ""), bookTitle, banLogVisible, punishment[1], DateFormat.getDateTimeInstance(DateFormat.SHORT, DateFormat.LONG).format(new Date()));
						formatter.close();
						
					} catch (FileNotFoundException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
					
				}	
				else if(punishment[0].equals("KICK") || punishment[0].equals("HIDE")) // Kicks, because you cannot pseudo-message a sign.
				{
					event.setCancelled(true);
					player.kickPlayer(ChatColor.RED + "You have been kicked for using vulgar language!");
					MinecraftChatFilter.numberOfKicks++;
				}
				else if(punishment[0].equals("UNICODE") || unicode) // Invalid unicode characters detected in either title or pages!
				{
					event.setCancelled(true);
					player.sendMessage(ChatColor.RED + "Please, don't use invalid characters!");
					MinecraftChatFilter.numberOfHides++;
				}
				else // No words detected, do nothing
				{
					
				}
				
	}
	
	@EventHandler
	public void onAnvilEvent(InventoryClickEvent event)
	{
		MinecraftChatFilter.numberOfEvents++;
		
		HumanEntity humanentity = event.getWhoClicked();
		
		if(humanentity instanceof Player) // If the event is from a player
		{
			Player player = (Player)humanentity;
			Inventory inventory = event.getInventory();
			
			if(inventory instanceof AnvilInventory) // If the event is about an anvil inventory
			{
				InventoryView view = event.getView();
				int rawSlot = event.getRawSlot();
				if(rawSlot == view.convertSlot(rawSlot))
				{
					if(rawSlot == 2)
					{
						ItemStack item = event.getCurrentItem();
						if(item != null)
						{
							ItemMeta meta = item.getItemMeta();
							if(meta != null)
							{
								if(meta.hasDisplayName())
								{
									String itemName = meta.getDisplayName();
									
									String[] punishment = check(itemName);
									
									if(punishment[0].equals("BAN")) // Permanent ban
									{
										event.setCancelled(true);  // Won't display the vulgar message
										player.setBanned(true);
										player.kickPlayer(ChatColor.RED + "You have been permanently banned for using extremely vulgar language!           " + ChatColor.GRAY + "Believe you've been banned unfairly?  Contact the owner of the server immediately!");
										MinecraftChatFilter.numberOfBans++;

										try {
											File directory = new File("MinecraftChatFilter" + File.separator + "banlogs");
											
											if(!directory.exists()) // If MinecraftChatFilter folder doesn't exist
											{
												directory.mkdirs(); // Then make it
											}
											
											Formatter formatter = new Formatter(directory + File.separator + player.getName() + ".txt");
											formatter.format("IGN: %s\r\nUUID: %s\r\nIP ADDRESS/PORT: %s\r\nANVIL ITEM NAME: %s\r\nDETECTED WORD: %s\r\nTIME: %s", player.getName(), player.getUniqueId(), player.getAddress().toString().replace("/", ""), itemName, punishment[1], DateFormat.getDateTimeInstance(DateFormat.SHORT, DateFormat.LONG).format(new Date()));
											formatter.close();
											
										} catch (FileNotFoundException e) {
											// TODO Auto-generated catch block
											e.printStackTrace();
										}
									}	
									else if(punishment[0].equals("KICK") || punishment[0].equals("HIDE")) // Kick
									{
										event.setCancelled(true);
										player.kickPlayer(ChatColor.RED + "You have been kicked for using vulgar language!");
										MinecraftChatFilter.numberOfKicks++;
									}
									else if(punishment[0].equals("UNICODE")) // Invalid unicode characters detected!
									{
										event.setCancelled(true);
										player.sendMessage(ChatColor.RED + "Please, don't use invalid characters!");
										MinecraftChatFilter.numberOfHides++;
									}
									else // No words detected, do nothing
									{
										
									}
								}
							}
						}
					}
				}
			}
		}
	}
	
	@EventHandler
	public void onSignEvent(SignChangeEvent event)
	{
		MinecraftChatFilter.numberOfEvents++;
		
		// Gets player from event
		Player player = event.getPlayer();
		
		// Gets the text from the sign
		String[] signText = event.getLines();
		
		// Is for the ban log.  Has multiple lines instead of just one line
		ArrayList<String> banLogVisible = new ArrayList<String>();
		
		// Sets the punishment to nothing by default
		String[] punishment = new String[2];
		punishment[0] = "NOTHING";
		
		// Sets the unicode boolean for the sign text
		boolean unicode = false;
		
		for(String lineText: signText)
		{
			// Checks each line on the sign
			String[] checkPunishment = check(lineText);
			
			// Checks to increase punishment
			if(checkPunishment[0].equals("BAN")) // If a ban is detected
			{
				// Sets the proper ban stuff.  Must have a break in the code!
				punishment[0] = "BAN";
				punishment[1] = checkPunishment[1];
				banLogVisible.add(lineText);
				break;
			}
			else if(checkPunishment[0].equals("KICK"))
			{
				// Sets punishment to a kick, but continues looking for any ban-level threats.
				banLogVisible.add(lineText);
				punishment[0] = "KICK";
			}
			else if(checkPunishment[0].equals("HIDE"))
			{
				banLogVisible.add(lineText);
				if(punishment[0].equals("NOTHING"))
				{
					// Will hide message.  Punishment must be lower than a hide already
					punishment[0] = "HIDE";
				}
			}
			else if(checkPunishment[0].equals("UNICODE")) // Special unicode characters detected in sign text
			{
				unicode = true;
			}
			else
			{
				banLogVisible.add(lineText);
			}
		}
		
		// Deals with punishments
		
		if(punishment[0].equals("BAN")) // Permanent ban
		{
			event.setCancelled(true);  // Hides message
			player.setBanned(true);
			player.kickPlayer(ChatColor.RED + "You have been permanently banned for using extremely vulgar language!           " + ChatColor.GRAY + "Believe you've been banned unfairly?  Contact the owner of the server immediately!");
			MinecraftChatFilter.numberOfBans++;

			try {
				File directory = new File("MinecraftChatFilter" + File.separator + "banlogs");
				
				if(!directory.exists()) // If MinecraftChatFilter folder doesn't exist
				{
					directory.mkdir(); // Make it
				}
				
				Formatter formatter = new Formatter(directory + File.separator + player.getName() + ".txt");
				formatter.format("IGN: %s\r\nUUID: %s\r\nIP ADDRESS/PORT: %s\r\nSIGN MESSAGE: %s\r\nDETECTED WORD: %s\r\nTIME: %s", player.getName(), player.getUniqueId(), player.getAddress().toString().replace("/", ""), banLogVisible, punishment[1], DateFormat.getDateTimeInstance(DateFormat.SHORT, DateFormat.LONG).format(new Date()));
				formatter.close();
				
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
		}	
		else if(punishment[0].equals("KICK") || punishment[0].equals("HIDE")) // Kicks
		{
			event.setCancelled(true);
			player.kickPlayer(ChatColor.RED + "You have been kicked for using vulgar language!");
			MinecraftChatFilter.numberOfKicks++;
		}
		else if(punishment[0].equals("UNICODE") || unicode) // Invalid unicode characters detected!!!
		{
			event.setCancelled(true);
			player.sendMessage(ChatColor.RED + "Please, don't use invalid characters!");
			MinecraftChatFilter.numberOfHides++;
		}
		else // No words detected, do nothing
		{
			
		}
	}
	
	@EventHandler
	public void onPlayerJoin(PlayerJoinEvent event)
	{
		MinecraftChatFilter.numberOfEvents++;
		// Gets player from login event
				Player player = event.getPlayer();
				
				// Checks name
				String[] punishment = check(player.getName());
				
				if(punishment[0].equals("BAN")) // Permanent ban
				{
					player.setBanned(true);
					player.kickPlayer(ChatColor.RED + "You have been permanently banned for using extremely vulgar language!           " + ChatColor.GRAY + "Believe you've been banned unfairly?  Contact the owner of the server immediately!");
					MinecraftChatFilter.numberOfBans++;

					try {
						File directory = new File("MinecraftChatFilter" + File.separator + "banlogs");
						
						if(!directory.exists()) // If MinecraftChatFilter folder doesn't exist
						{
							directory.mkdir(); // Make it
						}
						
						Formatter formatter = new Formatter(directory + File.separator + player.getName() + ".txt");
						formatter.format("IGN: %s\r\nUUID: %s\r\nIP ADDRESS/PORT: %s\r\nDETECTED WORD: %s\r\nTIME: %s", player.getName(), player.getUniqueId(), player.getAddress().toString().replace("/", ""), punishment[1], DateFormat.getDateTimeInstance(DateFormat.SHORT, DateFormat.LONG).format(new Date()));
						formatter.close();
						
					} catch (FileNotFoundException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
					
				}	
				else if(punishment[0].equals("KICK") || punishment[0].equals("HIDE")) // Kicks
				{
					player.kickPlayer(ChatColor.RED + "You have been kicked for having a vulgar username!");
					MinecraftChatFilter.numberOfKicks++;
				}
				else // No words detected, do nothing.  Minecraft usernames aren't allowed to have unicode characters in them :)
				{
					
				}
	}
	
	@EventHandler
	public void onChat(PlayerChatEvent event)
	{
		MinecraftChatFilter.numberOfEvents++;
		
		Player player = event.getPlayer();
		
		String[] punishment = check(event.getMessage());
		
		if(punishment[0].equals("BAN")) // Permanent ban
		{
			event.setCancelled(true);  // Hides vulgar message
			player.setBanned(true);
			player.kickPlayer(ChatColor.RED + "You have been permanently banned for using extremely vulgar language!           " + ChatColor.GRAY + "Believe you've been banned unfairly?  Contact the owner of the server immediately!");
			MinecraftChatFilter.numberOfBans++;

			try {
				File directory = new File("MinecraftChatFilter" + File.separator + "banlogs");
				
				if(!directory.exists()) // If MinecraftChatFilter folder doesn't exist
				{
					directory.mkdirs(); // Make it
				}
				
				Formatter formatter = new Formatter(directory + File.separator + player.getName() + ".txt");
				formatter.format("IGN: %s\r\nUUID: %s\r\nIP ADDRESS/PORT: %s\r\nCHAT MESSAGE: %s\r\nDETECTED WORD: %s\r\nTIME: %s", player.getName(), player.getUniqueId(), player.getAddress().toString().replace("/", ""), event.getMessage(), punishment[1], DateFormat.getDateTimeInstance(DateFormat.SHORT, DateFormat.LONG).format(new Date()));
				formatter.close();
				
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
		}	
		else if(punishment[0].equals("KICK")) // Kick
		{
			event.setCancelled(true);
			player.kickPlayer(ChatColor.RED + "You have been kicked for using vulgar language!");
			MinecraftChatFilter.numberOfKicks++;
		}
		else if(punishment[0].equals("HIDE"))  // Hide
		{
			// This is where you put/edit the code for the fake message!  In case a server rank changes their chat color or something
			event.setCancelled(true);
			player.sendMessage("<" + player.getDisplayName() + "> " + event.getMessage());  // Send fake message!
			MinecraftChatFilter.numberOfHides++;
		}
		else if(punishment[0].equals("UNICODE")) // Invalid unicode characters detected!
		{
			event.setCancelled(true);
			player.sendMessage(ChatColor.RED + "Please, don't use invalid characters!");
			MinecraftChatFilter.numberOfHides++;
		}
		else // No words detected, do nothing
		{
			
		}
	}
}